class HouseEvent < WorldEvent
  def initialize game
    @game = game
    @title = "an old house"
    @combat_tick = 0
    super @game.world.stores
  end

  def replenishes_water?
    true
  end

  def init_scenes
    leave = { :next_scene => :end }
    clear = { :next_scene => :clear }

    @scenes = {
      :start => {
        :text =>  [
          'an old house remains here, once white siding yellowed and peeling.',
          'the door hangs open. water replenished.'
        ],
        :options => {
          :go_inside => {
            :next_scene => { 0.3 => :supplies, 1 => :occupied }
          },
          :leave => leave
        },
      },
      :supplies => {
        :text => [
          'the house is abandoned, but not yet picked over.',
          'still a few drops of water in the old well.'
        ],
        :loot => {
          :cured_meat => { :min => 7, :max => 10, :chance => 1.0 },
          :leather => { :min => 1, :max => 10, :chance => 1.0 },
          :cloth => { :min => 1, :max => 3, :chance => 0.5 }
        },
        :options => { :leave => clear }
      },
      :occupied => {
        :text => [ 'a man charges down the hall, a rusty blade in his hand.' ],
        :combat => true,
        :enemy => :squatter,
        :damage => 2,
        :hit => 1.0,
        :attack_delay => 3,
        :health => 8,
        :max_health => 8,
        :loot => {
          :cured_meat => { :min => 7, :max => 10, :chance => 1.0 },
          :leather => { :min => 5, :max => 10, :chance => 1.0 },
          :cloth => { :min => 1, :max => 3, :chance => 1.0
                    }
        },
        :options => {
          :continue => clear,
          :run => leave
        }
      }
    }
  end
end

class SafeHouseEvent < WorldEvent
  def initialize game
    @game = game
    @title = "an old house"
    @combat_tick = 0
    super @game.world.stores
  end

  def replenishes_water?
    true
  end

  def becomes_outpost?
    true
  end

  def init_scenes
    leave = { :next_scene => :end }
    clear = { :next_scene => :clear }

    @scenes = {
      :start => {
        :text => [
          'an old house remains here, once white siding yellowed and peeling.',
          'the door hangs open. water replenished.'
        ],
        :options => {
          :go_inside => {
            :next_scene => { 0.01 => :supplies, 1 => :occupied }
          },
          :leave => leave
        },
      },
      :supplies => {
        :text => [
          'the house is abandoned, but not yet picked over.',
          'still a few drops of water in the old well.'
        ],
        :loot => {
          :cured_meat => { :min => 7, :max => 10, :chance => 1.0 },
          :leather => { :min => 1, :max => 10, :chance => 1.0 },
          :cloth => { :min => 1, :max => 2, :chance => 0.5 }
        },
        :options => { :leave => clear }
      },
      :occupied => {
        :text => [ 'a man charges down the hall, a rusty blade in his hand.' ],
        :combat => true,
        :enemy => :squatter,
        :damage => 2,
        :hit => 1.0,
        :attack_delay => 3,
        :health => 8,
        :max_health => 8,
        :loot => {
          :cured_meat => { :min => 7, :max => 10, :chance => 1.0 },
          :leather => { :min => 5, :max => 10, :chance => 1.0 },
          :cloth => { :min => 1, :max => 2, :chance => 1.0
                    }
        },
        :options => {
          :continue => clear,
          :run => leave
        }
      }
    }
  end
end
