module LayoutRepl
  def repl_code_labels game
    set_current_repl_code(get_current_repl_code || "")
    running_y = 65
    _, y, _, _ = repl_cursor_location

    if y > 360
      running_y -= (y - 360)
    end

    running_cursor_index = 0
    labels = get_current_repl_code.each_line.map do |l|
      text = [60, running_y, l + "\n", 0, 0, 255, 255, 255, 1]
      running_y += 23
      text
    end
    labels
  end
end

def thick_line kaigi, x, y, x2, y2, r, g, b
  start_x = kaigi.start_x
  start_y = kaigi.start_y
  kaigi.lines   << [start_x + x - 2, start_y + y, start_x + x2 - 2, start_y + y2, r, g, b]
  kaigi.lines   << [start_x + x - 1, start_y + y, start_x + x2 - 1, start_y + y2, r, g, b]
  kaigi.lines   << [start_x + x,     start_y + y, start_x + x2,     start_y + y2, r, g, b]
  kaigi.lines   << [start_x + x + 1, start_y + y, start_x + x2 + 1, start_y + y2, r, g, b]
  kaigi.lines   << [start_x + x + 2, start_y + y, start_x + x2 + 2, start_y + y2, r, g, b]

  kaigi.lines   << [start_x + x,     start_y + y - 2, start_x + x2, start_y + y2 - 2, r, g, b]
  kaigi.lines   << [start_x + x,     start_y + y - 1, start_x + x2, start_y + y2 - 1, r, g, b]
  kaigi.lines   << [start_x + x,     start_y + y + 0, start_x + x2, start_y + y2 + 0, r, g, b]
  kaigi.lines   << [start_x + x,     start_y + y + 1, start_x + x2, start_y + y2 + 1, r, g, b]
  kaigi.lines   << [start_x + x,     start_y + y + 2, start_x + x2, start_y + y2 + 2, r, g, b]
end

def tick kaigi
  kaigi.start_x ||= 425
  kaigi.start_y ||= 375
  
  kaigi.solids  << [0, 0, 1280, 720, 28, 22, 69]
  kaigi.labels  << [600, 500, "RubyKaigi 2019", 2, 0, 255, 255, 255]

  red = [186, 62, 40]
  orange = [241, 148, 55]
  dark_blue = [61,  94, 165]
  light_blue = [83, 186,  212]

  thick_line kaigi, 100, 140, 95, 95, *light_blue
  thick_line kaigi, 140, 105, 95, 95, *orange
  thick_line kaigi, 140, 105, 120, 60, *red
  thick_line kaigi, 155,  50, 120, 60, *dark_blue
  thick_line kaigi, 100, 140, 60, 110, *orange
  thick_line kaigi,  50, 155, 60, 110, *dark_blue
  thick_line kaigi, 100, 140, 150, 150, *red
  thick_line kaigi, 140, 105, 150, 150, *dark_blue
  thick_line kaigi, 150, 150, 155,  50, *orange
  thick_line kaigi, 150, 150,  50, 155, *orange
  thick_line kaigi, 100, 140,  50, 155, *orange
  thick_line kaigi, 140, 105, 155,  50, *orange
  thick_line kaigi, 140, 105, 100, 140, *red
  thick_line kaigi, 52, 156, 33, 110, *orange
  thick_line kaigi, 33, 112, 61, 113, *light_blue
  thick_line kaigi, 61, 113, 95, 95, *light_blue
  thick_line kaigi, 95, 95, 120, 63, *light_blue
  thick_line kaigi, 120, 62, 136, 39, *orange
  thick_line kaigi, 155, 52, 138, 39, *red
  thick_line kaigi, 51, 155, 29, 143, *red
  thick_line kaigi, 30, 145, 34, 114, *red
  thick_line kaigi, 136, 40, 110, 41, *red
  thick_line kaigi, 120, 62, 111, 40, *light_blue
  thick_line kaigi, 34, 112, 39, 87, *light_blue
  thick_line kaigi, 112, 42, 83, 53, *light_blue
  thick_line kaigi, 38, 89, 88, 51, *light_blue

  kaigi.debounce ||= 0
  
  if kaigi.player_1_a
    kaigi.debounce = 100
  end
  
  kaigi.debounce -= 1
  
  if kaigi.debounce > 0
    kaigi.labels << [400, 300, "(please clap and celebrate very loudly ", 1, 0, 255, 255, 255, 255]
    kaigi.labels << [400, 330, " so the entire conference hears us!!)", 1, 0, 255, 255, 255, 255]
    
    100.times do
      kaigi.solids << [1280 * rand, 720 * rand, 3, 3, 255 * rand, 255 * rand, 255 * rand, 255]
    end
  end
  
  if kaigi.player_1_right_key_held
    kaigi.start_x += 5
  elsif kaigi.player_1_left_key_held
    kaigi.start_x -= 5
  elsif kaigi.player_1_up_key_held
    kaigi.start_y -= 5
  elsif kaigi.player_1_down_key_held
    kaigi.start_y += 5
  end
end
