module LayoutLoot
  def loot_nav
    [
      [:loot_take_cured_meat_button,  :loot_drop_cured_meat_button,   :loot_take_jewel_button,       :loot_drop_jewel_button],
      [:loot_take_bone_spear_button,  :loot_drop_bone_spear_button,   :loot_take_fur_button,         :loot_drop_fur_button],
      [:loot_take_torch_button,       :loot_drop_torch_button,        :loot_take_meat_button,        :loot_drop_meat_button],
      [:loot_take_bolas_button,       :loot_drop_bolas_button,        :loot_take_scales_button,      :loot_drop_scales_button],
      [:loot_take_iron_sword_button,  :loot_drop_iron_sword_button,   :loot_take_teeth_button,       :loot_drop_teeth_button],
      [:loot_take_steel_sword_button, :loot_drop_steel_sword_button,  :loot_take_cloth_button,       :loot_drop_cloth_button],
      [:loot_take_katana_button,      :loot_drop_katana_button,       :loot_take_leather_button,     :loot_drop_leather_button],
      [:loot_take_rifle_button,       :loot_drop_rifle_button,        :loot_take_iron_button,        :loot_drop_iron_button],
      [:loot_take_bullet_button,      :loot_drop_bullet_button,       :loot_take_coal_button,        :loot_drop_coal_button],
      [:loot_take_carbine_button,     :loot_drop_carbine_button,      :loot_take_steel_button,       :loot_drop_steel_button],
      [:loot_take_battery_button,     :loot_drop_battery_button,      :loot_take_sulphur_button,     :loot_drop_sulphur_button],
      [:loot_take_grenade_button,     :loot_drop_grenade_button,      :loot_take_alien_alloy_button, :loot_drop_alien_alloy_button],
      [:loot_continue_button,         :loot_continue_button,          :loot_continue_button,         :loot_continue_button],
      [:loot_run_button,              :loot_run_button,               :loot_run_button,              :loot_run_button]
    ]
  end

  def loot_borders game
    return nil unless game.active_module == :loot

    [
      640, 85, 2, 540
    ]
  end

  def loot_accept_pressed game, player
    return false unless game.active_module == :loot

      current_weight = game.world.stores_weight

    if @selected_control[player] == :loot_take_cured_meat_button
      game.world.take_stores :cured_meat, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_cured_meat_button
      game.world.drop_stores :cured_meat, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_bone_spear_button
      game.world.take_stores :bone_spear, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_bone_spear_button
      game.world.drop_stores :bone_spear, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_torch_button
      game.world.take_stores :torch, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_torch_button
      game.world.drop_stores :torch, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_bolas_button
      game.world.take_stores :bolas, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_bolas_button
      game.world.drop_stores :bolas, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_iron_sword_button
      game.world.take_stores :iron_sword, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_iron_sword_button
      game.world.drop_stores :iron_sword, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_steel_sword_button
      game.world.take_stores :steel_sword, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_steel_sword_button
      game.world.drop_stores :steel_sword, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_katana_button
      game.world.take_stores :katana, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_katana_button
      game.world.drop_stores :katana, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_rifle_button
      game.world.take_stores :rifle, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_rifle_button
      game.world.drop_stores :rifle, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_bullet_button
      game.world.take_stores :bullet, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_bullet_button
      game.world.drop_stores :bullet, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_carbine_button
      game.world.take_stores :carbine, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_carbine_button
      game.world.drop_stores :carbine, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_battery_button
      game.world.take_stores :battery, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_battery_button
      game.world.drop_stores :battery, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_grenade_button
      game.world.take_stores :grenade, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_grenade_button
      game.world.drop_stores :grenade, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_jewel_button
      game.world.take_stores :jewel, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_jewel_button
      game.world.drop_stores :jewel, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_fur_button
      game.world.take_stores :fur, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_fur_button
      game.world.drop_stores :fur, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_meat_button
      game.world.take_stores :meat, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_meat_button
      game.world.drop_stores :meat, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_scales_button
      game.world.take_stores :scales, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_scales_button
      game.world.drop_stores :scales, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_teeth_button
      game.world.take_stores :teeth, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_teeth_button
      game.world.drop_stores :teeth, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_cloth_button
      game.world.take_stores :cloth, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_cloth_button
      game.world.drop_stores :cloth, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_leather_button
      game.world.take_stores :leather, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_leather_button
      game.world.drop_stores :leather, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_iron_button
      game.world.take_stores :iron, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_iron_button
      game.world.drop_stores :iron, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_coal_button
      game.world.take_stores :coal, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_coal_button
      game.world.drop_stores :coal, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_steel_button
      game.world.take_stores :steel, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_steel_button
      game.world.drop_stores :steel, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_sulphur_button
      game.world.take_stores :sulphur, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_sulphur_button
      game.world.drop_stores :sulphur, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_take_alien_alloy_button
      game.world.take_stores :alien_alloy, @loot_layout_current_loot
      queue_sound 'sounds/allocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_drop_alien_alloy_button
      game.world.drop_stores :alien_alloy, @loot_layout_current_loot
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_continue_button
      loot_continue_button_accepted game
      queue_sound 'sounds/deallocate.wav' if game.world.stores_weight != current_weight
      return true
    end

    if @selected_control[player] == :loot_run_button
      loot_run_button_accepted game
      return true
    end

    return false
  end

  def loot_event_ended? game
    return true if !game.world.event

    game.world.event.current_scene == :end
  end

  def loot_run_button_accepted game
    carry = game.world.carry
    current_scene = loot_current_scene game

    if game.world.stores_weight > carry[:max]
      carry = game.world.carry
      alert_show "encumbered",
                 ["can't carry this much: #{carry[:name]}, can only carry a maximum of #{carry[:max]}."],
                 :loot,
                 game
    else
      if current_scene[:options][:run]
        game.world.event.change_scene(:run)
      else
        game.world.event.change_scene(:leave)
      end

      if loot_event_ended? game
        game.world.event = nil
        @loot_layout_current_loot = nil
        show_scene :world, nil, game
      else
        current_scene = loot_current_scene game
        if game.world.event && game.world.event.in_battle?
          show_scene :world_event_battle, nil, game
        else
          show_scene :world_event, nil, game
        end
        @loot_layout_current_loot = nil
      end
    end
  end

  def loot_continue_button_accepted game
    carry = game.world.carry
    current_scene = loot_current_scene game

    if game.world.stores_weight > carry[:max]
      carry = game.world.carry
      alert_show "encumbered",
                 ["can't carry this much: #{carry[:name]}, can only carry a maximum of #{carry[:max]}."],
                 :loot,
                 game
    else
      if current_scene[:options][:continue]
        game.world.event.change_scene(:continue)
      else
        game.world.event.change_scene(:leave)
      end

      if loot_event_ended? game
        game.world.event = nil
        @loot_layout_current_loot = nil
        show_scene :world, nil, game
      else
        current_scene = loot_current_scene game
        if game.world.event && game.world.event.in_battle?
          show_scene :world_event_battle, nil, game
        else
          show_scene :world_event, nil, game
        end
        @loot_layout_current_loot = nil
      end
    end
  end

  def loot_buttons game
    return nil unless game.active_module == :loot

    [
      loot_continue_button(game),
      loot_run_button(game),
    ]
  end

  def loot_sprite_buttons game
    return nil unless game.active_module == :loot

    [
      loot_take_cured_meat_button(game),  loot_drop_cured_meat_button(game),
      loot_take_bone_spear_button(game),  loot_drop_bone_spear_button(game),
      loot_take_cured_meat_button(game),  loot_drop_cured_meat_button(game),
      loot_take_bone_spear_button(game),  loot_drop_bone_spear_button(game),
      loot_take_torch_button(game),       loot_drop_torch_button(game),
      loot_take_bolas_button(game),       loot_drop_bolas_button(game),
      loot_take_iron_sword_button(game),  loot_drop_iron_sword_button(game),
      loot_take_steel_sword_button(game), loot_drop_steel_sword_button(game),
      loot_take_katana_button(game),      loot_drop_katana_button(game),
      loot_take_rifle_button(game),       loot_drop_rifle_button(game),
      loot_take_bullet_button(game),      loot_drop_bullet_button(game),
      loot_take_carbine_button(game),     loot_drop_carbine_button(game),
      loot_take_battery_button(game),     loot_drop_battery_button(game),
      loot_take_grenade_button(game),     loot_drop_grenade_button(game),
      loot_take_jewel_button(game),       loot_drop_jewel_button(game),
      loot_take_fur_button(game),         loot_drop_fur_button(game),
      loot_take_meat_button(game),        loot_drop_meat_button(game),
      loot_take_scales_button(game),      loot_drop_scales_button(game),
      loot_take_teeth_button(game),       loot_drop_teeth_button(game),
      loot_take_cloth_button(game),       loot_drop_cloth_button(game),
      loot_take_leather_button(game),     loot_drop_leather_button(game),
      loot_take_iron_button(game),        loot_drop_iron_button(game),
      loot_take_coal_button(game),        loot_drop_coal_button(game),
      loot_take_steel_button(game),       loot_drop_steel_button(game),
      loot_take_sulphur_button(game),     loot_drop_sulphur_button(game),
      loot_take_alien_alloy_button(game), loot_drop_alien_alloy_button(game)
    ]
  end

  def loot_current_scene game
    return { text: [] } if !game.world.event

    game.world.event.scenes[game.world.event.current_scene]
  end

  def loot_can_run? game
    current_scene = loot_current_scene game
    return false if !current_scene
    return false if !current_scene[:options]
    current_scene[:options][:run]
  end


  def loot_continue_button game
    if loot_can_run? game
      [360, 640, 277, 30, Translations.value("continue")]
    else
      [360, 640, 540, 30, Translations.value("continue")]
    end
  end

  def loot_run_button game
    return nil if !loot_can_run? game
    [645, 640, 277, 30, Translations.value("run")]
  end

  def loot_dismissed game

  end

  def loot_shown game
    @loot_label_spots_left = {}
    @loot_label_spots_right = {}
    @loot_button_spots_left = {}
    @loot_button_spots_right = {}
    @flash_on_floor = true
  end

  def loot_labels game
    return nil unless game.active_module == :loot

    if @world_current_fire_state_for_world != game.room.fire
      @world_current_fire_state_for_world = game.room.fire
      queue_sound 'sounds/voices.wav'
    end

    square = 40

    result = [
      [(width / 2).to_i, square - 10, Translations.value("loot"), 1, 1],
      *loot_equipment_labels(game),
      *loot_allocation_cured_meat_label(game),
      *loot_allocation_bone_spear_label(game),
      *loot_allocation_torch_label(game),
      *loot_allocation_bolas_label(game),
      *loot_allocation_iron_sword_label(game),
      *loot_allocation_steel_sword_label(game),
      *loot_allocation_katana_label(game),
      *loot_allocation_rifle_label(game),
      *loot_allocation_bullet_label(game),
      *loot_allocation_carbine_label(game),
      *loot_allocation_battery_label(game),
      *loot_allocation_grenade_label(game),
      *loot_allocation_jewel_label(game),
      *loot_allocation_fur_label(game),
      *loot_allocation_meat_label(game),
      *loot_allocation_scales_label(game),
      *loot_allocation_teeth_label(game),
      *loot_allocation_cloth_label(game),
      *loot_allocation_leather_label(game),
      *loot_allocation_iron_label(game),
      *loot_allocation_coal_label(game),
      *loot_allocation_steel_label(game),
      *loot_allocation_sulphur_label(game),
      *loot_allocation_alien_alloy_label(game)
    ]

    @flash_on_floor = false

    result
  end


  def loot_equipment_labels game
    [
      [640, 80, Translations.value("#{game.world.carry[:name]}:") +
                " #{game.world.stores_weight}" + Translations.value(" of #{game.world.carry[:max]} weight"), 0, center_aligned],
    ]
  end

  def loot_pad_number n
    return   "#{n}"   if n >= 100
    return  " #{n}"  if n >= 10
    return "  #{n}"
  end

  def loot_take_drop_button_y_px row
    side = :left
    side = :right if (row + 1) > 12
    target_spot = @loot_label_spots_left

    if side == :right
      target_spot = @loot_label_spots_right
    end

    if (row + 1) > 12
      row -= 12
    end

    if !target_spot[row]
      target_spot[row] = 90 + (target_spot.keys.length * 37)
    end

    target_spot[row]
  end

  def loot_allocation_label_x_px row
    if (row + 1) > 12
      665
    else
      28
    end
  end

  def loot_allocation_label_y_px row
    side = :left
    side = :right if (row + 1) > 12
    target_spot = @loot_button_spots_left

    if side == :right
      target_spot = @loot_button_spots_right
    end

    if (row + 1) > 12
      row -= 12
    end

    if !target_spot[row]
      target_spot[row] = (120 + (target_spot.keys.count * 37)).to_i
    end

    target_spot[row]
  end

  def loot_has_equipment? game, equipment
    @loot_layout_current_loot ||= game.world.event.loot_sample
    game.world.stores[equipment] || @loot_layout_current_loot[equipment]
  end

  def loot_take_button game, equipment, row, override_text = nil
    return nil unless loot_has_equipment? game, equipment

    x = 1197
    x = 557 if (row + 1) <= 12

    [x, loot_take_drop_button_y_px(row), 28, 30, override_text || "+"]
  end

  def loot_drop_button game, equipment, row, override_text = nil
    return nil unless loot_has_equipment? game, equipment

    x = 1232
    x = 592 if (row + 1) <= 12

    [x, loot_take_drop_button_y_px(row), 28, 30, override_text || "-"]
  end

  def loot_take_cured_meat_button game
    loot_take_button game, :cured_meat, 0
  end

  def loot_drop_cured_meat_button game
    loot_drop_button game, :cured_meat, 0
  end

  def loot_take_bone_spear_button game
    loot_take_button game, :bone_spear, 1
  end

  def loot_drop_bone_spear_button game
    loot_drop_button game, :bone_spear, 1
  end

  def loot_take_torch_button game
    loot_take_button game, :torch, 2
  end

  def loot_drop_torch_button game
    loot_drop_button game, :torch, 2
  end

  def loot_take_bolas_button game
    loot_take_button game, :bolas, 3
  end

  def loot_drop_bolas_button game
    loot_drop_button game, :bolas, 3
  end

  def loot_take_iron_sword_button game
    loot_take_button game, :iron_sword, 4
  end

  def loot_drop_iron_sword_button game
    loot_drop_button game, :iron_sword, 4
  end

  def loot_take_steel_sword_button game
    loot_take_button game, :steel_sword, 5
  end

  def loot_drop_steel_sword_button game
    loot_drop_button game, :steel_sword, 5
  end

  def loot_take_katana_button game
    loot_take_button game, :katana, 6
  end

  def loot_drop_katana_button game
    loot_drop_button game, :katana, 6
  end

  def loot_take_rifle_button game
    loot_take_button game, :rifle, 7
  end

  def loot_drop_rifle_button game
    loot_drop_button game, :rifle, 7
  end

  def loot_take_bullet_button game
    loot_take_button game, :bullet, 8
  end

  def loot_drop_bullet_button game
    loot_drop_button game, :bullet, 8
  end

  def loot_take_carbine_button game
    loot_take_button game, :carbine, 9
  end

  def loot_drop_carbine_button game
    loot_drop_button game, :carbine, 9
  end

  def loot_take_battery_button game
    loot_take_button game, :battery, 10
  end

  def loot_drop_battery_button game
    loot_drop_button game, :battery, 10
  end

  def loot_take_grenade_button game
    loot_take_button game, :grenade, 11
  end

  def loot_drop_grenade_button game
    loot_drop_button game, :grenade, 11
  end

  def loot_take_jewel_button game
    loot_take_button game, :jewel, 12
  end

  def loot_drop_jewel_button game
    loot_drop_button game, :jewel, 12
  end

  def loot_allocation_label game, equipment, row
    return nil unless loot_has_equipment? game, equipment

    x = loot_allocation_label_x_px row
    y = loot_allocation_label_y_px row
    header_label = Translations.value("#{word_lookup equipment}") + " "
    key_count = game.world.stores[equipment] || 0
    loot_count = @loot_layout_current_loot[equipment] || 0
    total_carry = game.world.weight_for(equipment) * key_count

    count_and_weight = Translations.value("floor:") + "#{loot_pad_number loot_count}" +
                        Translations.value(", ") + Translations.value("carry:") + "#{loot_pad_number key_count}"
    space_count = if Translations.language == :japanese
                    length = japanese_word_length(header_label) + japanese_word_length(count_and_weight)
                    length += 1 if (japanese_word_length(header_label)/1.3).to_i == 3
                    length += 2 if (japanese_word_length(header_label)/1.3).to_i == 4
                    length += 3 if (japanese_word_length(header_label)/1.3).to_i == 5
                    length += 4 if (japanese_word_length(header_label)/1.3).to_i == 7
                    30 - length
                  else
                    35 - (header_label.to_s.length + count_and_weight.to_s.length)
                  end

    spacing = " " * space_count if space_count > 0

    if @flash_on_floor && loot_count > 0
      queue_flash equipment, x - 5, y - 32, 605, 35, 100, 100, 200, 1 / 100.0
    end

    [
      [x, y, "#{header_label}#{spacing}#{count_and_weight}", 0, left_aligned]
    ]
  end

  def loot_allocation_cured_meat_label game
    loot_allocation_label game, :cured_meat, 0
  end

  def loot_allocation_bone_spear_label game
    loot_allocation_label game, :bone_spear, 1
  end

  def loot_allocation_torch_label game
    loot_allocation_label game, :torch, 2
  end

  def loot_allocation_bolas_label game
    loot_allocation_label game, :bolas, 3
  end

  def loot_allocation_iron_sword_label game
    loot_allocation_label game, :iron_sword, 4
  end

  def loot_allocation_steel_sword_label game
    loot_allocation_label game, :steel_sword, 5
  end

  def loot_allocation_katana_label game
    loot_allocation_label game, :katana, 6
  end

  def loot_allocation_rifle_label game
    loot_allocation_label game, :rifle, 7
  end

  def loot_allocation_bullet_label game
    loot_allocation_label game, :bullet, 8
  end

  def loot_allocation_carbine_label game
    loot_allocation_label game, :carbine, 9
  end

  def loot_allocation_battery_label game
    loot_allocation_label game, :battery, 10
  end

  def loot_allocation_grenade_label game
    loot_allocation_label game, :grenade, 11
  end

  def loot_allocation_jewel_label game
    loot_allocation_label game, :jewel, 12
  end

  def loot_allocation_fur_label game
    loot_allocation_label game, :fur, 13
  end

  def loot_allocation_meat_label game
    loot_allocation_label game, :meat, 14
  end

  def loot_allocation_scales_label game
    loot_allocation_label game, :scales, 15
  end

  def loot_allocation_teeth_label game
    loot_allocation_label game, :teeth, 16
  end

  def loot_allocation_cloth_label game
    loot_allocation_label game, :cloth, 17
  end

  def loot_allocation_leather_label game
    loot_allocation_label game, :leather, 18
  end

  def loot_allocation_iron_label game
    loot_allocation_label game, :iron, 19
  end

  def loot_allocation_coal_label game
    loot_allocation_label game, :coal, 20
  end

  def loot_allocation_steel_label game
    loot_allocation_label game, :steel, 21
  end

  def loot_allocation_sulphur_label game
    loot_allocation_label game, :sulphur, 22
  end

  def loot_allocation_alien_alloy_label game
    loot_allocation_label game, :alien_alloy, 23
  end

  def loot_take_fur_button game
    loot_take_button game, :fur, 13
  end

  def loot_drop_fur_button game
    loot_drop_button game, :fur, 13
  end

  def loot_take_meat_button game
    loot_take_button game, :meat, 14
  end

  def loot_drop_meat_button game
    loot_drop_button game, :meat, 14
  end

  def loot_take_scales_button game
    loot_take_button game, :scales, 15
  end

  def loot_drop_scales_button game
    loot_drop_button game, :scales, 15
  end

  def loot_take_teeth_button game
    loot_take_button game, :teeth, 16
  end

  def loot_drop_teeth_button game
    loot_drop_button game, :teeth, 16
  end

  def loot_take_cloth_button game
    loot_take_button game, :cloth, 17
  end

  def loot_drop_cloth_button game
    loot_drop_button game, :cloth, 17
  end

  def loot_take_leather_button game
    loot_take_button game, :leather, 18
  end

  def loot_drop_leather_button game
    loot_drop_button game, :leather, 18
  end

  def loot_take_iron_button game
    loot_take_button game, :iron, 19
  end

  def loot_drop_iron_button game
    loot_drop_button game, :iron, 19
  end

  def loot_take_coal_button game
    loot_take_button game, :coal, 20
  end

  def loot_drop_coal_button game
    loot_drop_button game, :coal, 20
  end

  def loot_take_steel_button game
    loot_take_button game, :steel, 21
  end

  def loot_drop_steel_button game
    loot_drop_button game, :steel, 21
  end

  def loot_take_sulphur_button game
    loot_take_button game, :sulphur, 22
  end

  def loot_drop_sulphur_button game
    loot_drop_button game, :sulphur, 22
  end

  def loot_take_alien_alloy_button game
    loot_take_button game, :alien_alloy, 23
  end

  def loot_drop_alien_alloy_button game
    loot_drop_button game, :alien_alloy, 23
  end
end
